std::future< _Res & > Class Template Reference
Concurrency » Futures

`#include <future>`

Inheritance diagram for std::future< _Res & >:
[legend]

## Public Member Functions

| future (const future &)=delete
| future (future &&__uf) noexcept
_Res & | get ()
future & | operator= (const future &)=delete
future & | operator= (future &&__fut) noexcept
shared_future< _Res & > | share () noexcept
bool | valid () const noexcept
void | wait () const
future_status | wait_for (const chrono::duration< _Rep, _Period > &__rel) const
future_status | wait_until (const chrono::time_point< _Clock, _Duration > &__abs) const

## Protected Types

typedef __future_base::_Result< _Res & > & | __result_type

## Protected Member Functions

__result_type | _M_get_result () const
void | _M_swap (__basic_future &__that) noexcept

## Friends

template<typename _Fn , typename... _Args>
future< __async_result_of< _Fn, _Args... > > | async (launch, _Fn &&, _Args &&...)
template<typename >
class | packaged_task
class | promise< _Res & >

## Detailed Description

template<typename _Res>
class std::future< _Res & >

Partial specialization for future<R&>

Definition at line 833 of file future.

## Member Typedef Documentation

## __result_type

typedef __future_base::_Result<_Res & >& std::__basic_future< _Res & >::__result_type

protected inherited

Definition at line 697 of file future.

## Constructor & Destructor Documentation

## future() [1/2]

template<typename _Res >

constexpr std::future< _Res & >::future | ( |  | ) |

inline constexpr noexcept

Definition at line 848 of file future.

## future() [2/2]

template<typename _Res >

std::future< _Res & >::future | ( | future< _Res & > && | __uf | ) |

inline noexcept

Move constructor.

Definition at line 851 of file future.

## Member Function Documentation

## _M_get_result()

__result_type std::__basic_future< _Res & >::_M_get_result | ( |  | ) | const

inline protected inherited

Wait for the state to be ready and rethrow any stored exception.

Definition at line 736 of file future.

## _M_swap()

void std::__basic_future< _Res & >::_M_swap | ( | __basic_future< _Res & > & | __that | ) |

inline protected noexcept inherited

Definition at line 745 of file future.

## get()

template<typename _Res >

_Res & std::future< _Res & >::get | ( |  | ) |

inline

Retrieving the value.

Definition at line 865 of file future.

## operator=()

template<typename _Res >

future & std::future< _Res & >::operator= | ( | future< _Res & > && | __fut | ) |

inline noexcept

Definition at line 857 of file future.

## valid()

bool std::__basic_future< _Res & >::valid | ( |  | ) | const

inline noexcept inherited

Definition at line 708 of file future.

## wait()

void std::__basic_future< _Res & >::wait | ( |  | ) | const

inline inherited

Definition at line 711 of file future.

## wait_for()

future_status std::__basic_future< _Res & >::wait_for | ( | const chrono::duration< _Rep, _Period > & | __rel | ) | const

inline inherited

Definition at line 719 of file future.

## wait_until()

future_status std::__basic_future< _Res & >::wait_until | ( | const chrono::time_point< _Clock, _Duration > & | __abs | ) | const

inline inherited

Definition at line 727 of file future.

## Friends And Related Symbol Documentation

## packaged_task

template<typename _Res >
template<typename >

friend class packaged_task

friend

Definition at line 836 of file future.

## promise< _Res & >

template<typename _Res >

friend class promise< _Res & >

friend

Definition at line 828 of file future.

The documentation for this class was generated from the following file:

- future